# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'GetPreferencesResult',
    'AwaitableGetPreferencesResult',
    'get_preferences',
    'get_preferences_output',
]

@pulumi.output_type
class GetPreferencesResult:
    def __init__(__self__, account_id=None, idle_connection=None):
        if account_id and not isinstance(account_id, str):
            raise TypeError("Expected argument 'account_id' to be a str")
        pulumi.set(__self__, "account_id", account_id)
        if idle_connection and not isinstance(idle_connection, list):
            raise TypeError("Expected argument 'idle_connection' to be a list")
        pulumi.set(__self__, "idle_connection", idle_connection)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> Optional[str]:
        """
        The AWS Account Id that the preference is associated with, used as the unique identifier for this resource.
        """
        return pulumi.get(self, "account_id")

    @property
    @pulumi.getter(name="idleConnection")
    def idle_connection(self) -> Optional[Sequence['outputs.PreferencesIdleConnectionPreferences']]:
        """
        A map for Idle Connection Preferences
        """
        return pulumi.get(self, "idle_connection")


class AwaitableGetPreferencesResult(GetPreferencesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPreferencesResult(
            account_id=self.account_id,
            idle_connection=self.idle_connection)


def get_preferences(account_id: Optional[str] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPreferencesResult:
    """
    Definition of AWS::SSMGuiConnect::Preferences Resource Type


    :param str account_id: The AWS Account Id that the preference is associated with, used as the unique identifier for this resource.
    """
    __args__ = dict()
    __args__['accountId'] = account_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('aws-native:ssmguiconnect:getPreferences', __args__, opts=opts, typ=GetPreferencesResult).value

    return AwaitableGetPreferencesResult(
        account_id=pulumi.get(__ret__, 'account_id'),
        idle_connection=pulumi.get(__ret__, 'idle_connection'))


@_utilities.lift_output_func(get_preferences)
def get_preferences_output(account_id: Optional[pulumi.Input[str]] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetPreferencesResult]:
    """
    Definition of AWS::SSMGuiConnect::Preferences Resource Type


    :param str account_id: The AWS Account Id that the preference is associated with, used as the unique identifier for this resource.
    """
    ...
